/*******************************************************************************
 * Copyright (c) 2000, 2022 IBM Corporation and others.
 *
 * This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *     Technical University Berlin - extended API and implementation
 *******************************************************************************/
package org.eclipse.jdt.internal.compiler.parser;

/**
 * IMPORTANT NOTE: These constants are dedicated to the internal Scanner implementation.
 * It is mirrored in org.eclipse.jdt.core.compiler public package where it is API.
 * The mirror implementation is using the backward compatible ITerminalSymbols constant
 * definitions (stable with 2.0), whereas the internal implementation uses TerminalTokens
 * which constant values reflect the latest parser generation state.
 */
/**
 * Maps each terminal symbol in the java-grammar into a unique integer.
 * This integer is used to represent the terminal when computing a parsing action.
 *
 * Disclaimer : These constant values are generated automatically using a Java
 * grammar, therefore their actual values are subject to change if new keywords
 * were added to the language (for instance, 'assert' is a keyword in 1.4).
 */
public interface TerminalTokens {

	// special tokens not part of grammar - not autogenerated
	int
							TokenNameNotAToken = 0,
							TokenNameWHITESPACE = 1000,
							TokenNameCOMMENT_LINE = 1001,
							TokenNameCOMMENT_BLOCK = 1002,
							TokenNameCOMMENT_JAVADOC = 1003,
							TokenNameSingleQuoteStringLiteral = 1004,
							TokenNameCOMMENT_MARKDOWN = 1005;

	static boolean isRestrictedKeyword(int tokenType) {
		return switch (tokenType) {
			case TokenNameRestrictedIdentifierYield, TokenNameRestrictedIdentifierrecord,TokenNameRestrictedIdentifierWhen,
					TokenNameRestrictedIdentifiersealed, TokenNameRestrictedIdentifierpermits -> true;
			default -> false;
		};
	}

	static int getRestrictedKeyword(char [] text) {
		if (text != null) {
			int len = text.length;
			if (len == 4 && text[0] == 'w' ||
				len == 5 && text[0] == 'y' ||
				len == 6 && (text[0] == 'r' || text[0] == 's') ||
				len == 7 && text[0] == 'p') {
				return getRestrictedKeyword(new String(text));
			}
		}
		return TokenNameNotAToken;
	}

	static int getRestrictedKeyword(String text) {
		return switch (text) {
			case "yield"   -> TokenNameRestrictedIdentifierYield;   //$NON-NLS-1$
			case "record"  -> TokenNameRestrictedIdentifierrecord;  //$NON-NLS-1$
			case "when"    -> TokenNameRestrictedIdentifierWhen;    //$NON-NLS-1$
			case "sealed"  -> TokenNameRestrictedIdentifiersealed;  //$NON-NLS-1$
			case "permits" -> TokenNameRestrictedIdentifierpermits; //$NON-NLS-1$
			default        -> TokenNameNotAToken;
		};
	}

	// BEGIN_AUTOGENERATED_REGION
	int TokenNameIdentifier = 16,
							TokenNameabstract = 57,
							TokenNameassert = 88,
							TokenNameboolean = 115,
							TokenNamebreak = 89,
							TokenNamebyte = 116,
							TokenNamecase = 117,
							TokenNamecatch = 118,
							TokenNamechar = 119,
							TokenNameclass = 76,
							TokenNamecontinue = 90,
							TokenNameconst = 153,
							TokenNamedefault = 83,
							TokenNamedo = 91,
							TokenNamedouble = 120,
							TokenNameelse = 132,
							TokenNameenum = 80,
							TokenNameextends = 100,
							TokenNamefalse = 42,
							TokenNamefinal = 58,
							TokenNamefinally = 129,
							TokenNamefloat = 121,
							TokenNamefor = 92,
							TokenNamegoto = 154,
							TokenNameif = 93,
							TokenNameimplements = 149,
							TokenNameimport = 122,
							TokenNameinstanceof = 18,
							TokenNameint = 123,
							TokenNameinterface = 79,
							TokenNamelong = 124,
							TokenNamenative = 59,
							TokenNamenew = 38,
							TokenNamenon_sealed = 60,
							TokenNamenull = 43,
							TokenNamepackage = 101,
							TokenNameprivate = 61,
							TokenNameprotected = 62,
							TokenNamepublic = 63,
							TokenNamereturn = 94,
							TokenNameshort = 125,
							TokenNamestatic = 44,
							TokenNamestrictfp = 64,
							TokenNamesuper = 36,
							TokenNameswitch = 65,
							TokenNamesynchronized = 54,
							TokenNamethis = 37,
							TokenNamethrow = 86,
							TokenNamethrows = 130,
							TokenNametransient = 66,
							TokenNametrue = 45,
							TokenNametry = 95,
							TokenNamevoid = 126,
							TokenNamevolatile = 67,
							TokenNamewhile = 87,
							TokenNamemodule = 131,
							TokenNameopen = 139,
							TokenNamerequires = 133,
							TokenNametransitive = 140,
							TokenNameexports = 134,
							TokenNameopens = 135,
							TokenNameto = 150,
							TokenNameuses = 136,
							TokenNameprovides = 137,
							TokenNamewith = 102,
							TokenNameas = 141,
							TokenNamebase = 33,
							TokenNamecallin = 68,
							TokenNameplayedBy = 151,
							TokenNameprecedence = 103,
							TokenNameteam = 55,
							TokenNametsuper = 40,
							TokenNamewithin = 96,
							TokenNamereplace = 142,
							TokenNameafter = 138,
							TokenNamebefore = 143,
							TokenNameget = 144,
							TokenNameset = 145,
							TokenNameIntegerLiteral = 46,
							TokenNameLongLiteral = 47,
							TokenNameFloatingPointLiteral = 48,
							TokenNameDoubleLiteral = 49,
							TokenNameCharacterLiteral = 50,
							TokenNameStringLiteral = 51,
							TokenNameTextBlock = 52,
							TokenNamePLUS_PLUS = 2,
							TokenNameMINUS_MINUS = 3,
							TokenNameEQUAL_EQUAL = 21,
							TokenNameLESS_EQUAL = 14,
							TokenNameGREATER_EQUAL = 15,
							TokenNameNOT_EQUAL = 22,
							TokenNameLEFT_SHIFT = 19,
							TokenNameRIGHT_SHIFT = 13,
							TokenNameUNSIGNED_RIGHT_SHIFT = 17,
							TokenNamePLUS_EQUAL = 104,
							TokenNameMINUS_EQUAL = 105,
							TokenNameMULTIPLY_EQUAL = 106,
							TokenNameDIVIDE_EQUAL = 107,
							TokenNameAND_EQUAL = 108,
							TokenNameOR_EQUAL = 109,
							TokenNameXOR_EQUAL = 110,
							TokenNameREMAINDER_EQUAL = 111,
							TokenNameLEFT_SHIFT_EQUAL = 112,
							TokenNameRIGHT_SHIFT_EQUAL = 113,
							TokenNameUNSIGNED_RIGHT_SHIFT_EQUAL = 114,
							TokenNameOR_OR = 31,
							TokenNameAND_AND = 30,
							TokenNamePLUS = 4,
							TokenNameMINUS = 5,
							TokenNameNOT = 71,
							TokenNameREMAINDER = 10,
							TokenNameXOR = 27,
							TokenNameAND = 23,
							TokenNameMULTIPLY = 9,
							TokenNameOR = 28,
							TokenNameTWIDDLE = 72,
							TokenNameDIVIDE = 11,
							TokenNameGREATER = 12,
							TokenNameLESS = 8,
							TokenNameLPAREN = 20,
							TokenNameRPAREN = 24,
							TokenNameLBRACE = 69,
							TokenNameRBRACE = 34,
							TokenNameLBRACKET = 6,
							TokenNameRBRACKET = 75,
							TokenNameSEMICOLON = 25,
							TokenNameQUESTION = 29,
							TokenNameCOLON = 70,
							TokenNameCOMMA = 32,
							TokenNameDOT = 1,
							TokenNameEQUAL = 84,
							TokenNameAT = 41,
							TokenNameELLIPSIS = 146,
							TokenNameARROW = 127,
							TokenNameCOLON_COLON = 7,
							TokenNameBeginLambda = 53,
							TokenNameBeginIntersectionCast = 73,
							TokenNameBeginTypeArguments = 85,
							TokenNameElidedSemicolonAndRightBrace = 77,
							TokenNameAT308 = 26,
							TokenNameAT308DOTDOTDOT = 152,
							TokenNameCaseArrow = 78,
							TokenNameRestrictedIdentifierYield = 97,
							TokenNameRestrictedIdentifierrecord = 81,
							TokenNameRestrictedIdentifiersealed = 56,
							TokenNameRestrictedIdentifierpermits = 147,
							TokenNameBeginCasePattern = 148,
							TokenNameRestrictedIdentifierWhen = 98,
							TokenNameUNDERSCORE = 35,
							TokenNameATOT = 128,
							TokenNameBINDIN = 82,
							TokenNameCALLOUT_OVERRIDE = 99,
							TokenNameBINDOUT = 74,
							TokenNameEOF = 39,
							TokenNameERROR = 155;
}
